
/*Horloge 6 digits 7 segments
* Pour afficheur 7 segments 6 digits.
*
* Un simple fil sur PIN D2 prends en compte
* le secteur 50 Hz par induction. Celui-ci
* synchronise le compteur.
* (Alimentation via Secteur)
*
* Bouton "Comptage/Stop" sur PIN D4
* avec résistance de tirage 4K7 à la masse
*
*               Stop
*    Pin 5_____ ----_____  + 5 Volts
*           |
*          [ ]  4,7 K
*           |
*         Masse
*
*             Minutes           
*    Pin 3_____ ----_____  + 5 Volts
*           |
*          [ ]  4,7 K
*           |
*         Masse
*
*              Heures
*    Pin 13____ ----_____  + 5 Volts
*           |
*          [ ]  4,7 K
*           |
*           Masse
*              
*
*
* Version 01 le 08 11 2016
*
* http://f5mna.free.fr
*/


#include "SevSeg.h"
SevSeg sevseg;

int compteur, heures, minutes, secondes, mn1, i, chiffre;
unsigned long h0, h1, nombre;
boolean decompte = false; 
boolean top = true;
boolean top1 = true;
boolean top2 = true;

long DerTempsRebond = 0;
long DelaiRebond = 50;

const int Bouton1 = A5;
int LireBt;
int EtatBouton;
int DerEtatBouton = LOW;

const int Bouton2 = 3;
const int Bouton3 = 13;

void setup() {
  Serial.begin (9600);
  pinMode(Bouton1, INPUT);
  pinMode(Bouton2, INPUT);
  pinMode(Bouton3, INPUT);
  byte numDigits = 6;                          // Nombre de digits     byte numDigits = 6;  pour afficher les heures
  byte digitPins[] = {A4, A3, 12, 11, 10, 9};  //
  byte segmentPins[] = {A0,A1,A2,5,6,7,8,0};  // a,b,c,d,e,f,g,point

  
  sevseg.begin(COMMON_ANODE, numDigits, digitPins, segmentPins); // COMMON_CATHODE selon afficheurs utilisés
  sevseg.setBrightness(100);  // Luminosité de 0 à 100
  heures = 0;
  minutes = 0;
  attachInterrupt(0, Seconde, RISING ); //ISR Interrupt 0 sur broche 2. détection front montant
}

void Seconde() {
  /////////  Decompte //////////////
  sevseg.refreshDisplay();
  if (decompte == true)compteur++;
  if (compteur == 50) {        // 50 Hz
    secondes ++;
    compteur = 0;
    // Serial.println (i);
  }

  if (secondes == 60) {
    minutes = minutes + 1;
    secondes = 0;
  }

  if (minutes == 60) {
    heures = heures + 1;
    minutes = 0;
  }
  if (heures > 23) heures = 0;

  
  h0 = (heures * 100);      // transforme le temps en nombre entier pour affichage 7 segments.
  h1 = (h0 * 100);

  mn1 = minutes * 100;
  nombre = (h1 + mn1 + secondes);
  sevseg.setNumber((nombre), 6); //  pour afficher les heures
}

void loop() {
  
////////  Bouton stop  //////////
  {
  LireBt = digitalRead(Bouton1);
  if (LireBt != DerEtatBouton) {
    DerTempsRebond = millis();
  }
  if ((millis() - DerTempsRebond) > DelaiRebond) {
    if (LireBt != EtatBouton) {
      EtatBouton = LireBt;
      if (EtatBouton == HIGH)   decompte = !decompte;
         }
      }    
  DerEtatBouton = LireBt;
  }
   
//////  Bouton réglage minutes  //////////
  int Val1 = digitalRead(Bouton2);
  if (Val1 == HIGH){
  decompte = false;  
  minutes ++;
  if (minutes > 59) minutes = 0;
  delay (200);}

//////  Bouton réglage heures  //////////
  int Val2 = digitalRead(Bouton3);
  if (Val2 == HIGH){
  decompte = false;  
  heures ++;
  if (heures > 23) heures = 0;  
  Serial.println (heures);
  Serial.println (nombre);
  delay (200);}
}
// Fin

